package a1_solutionUsingSubclassing;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;

public class CircularVisualMass extends VisualMass {

	public CircularVisualMass(double vmCentreXRelativeToImage,
			double vmCentreYRelativeToImage, double vmWidthRelativeToImage,
			double vmHeightRelativeToImage) {
		super(vmCentreXRelativeToImage, vmCentreYRelativeToImage,
				vmWidthRelativeToImage, vmHeightRelativeToImage);
	}

	@Override
	public Shape getOutlineForVisualMass(Dimension size) {
		Point centre = getCentreOfVisualMass(size);
		int width = (int) Math.floor(size.width
				* getWidthRelativeToImage());
		int height = (int) Math.floor(size.height
				* getHeightRelativeToImage());
		Point anchor = new Point(centre.x - width / 2, centre.y - height / 2);
		Shape theShape = new Ellipse2D.Float(anchor.x, anchor.y, width,
				height);
		return theShape;
	}
}
